#!/usr/bin/python
# -*- coding: utf-8 -*-

import tkinter as tk
from tkinter.ttk import *
from tkinter import *


class AusgabeWindow(tk.Frame):
    __binOutput = None

    def __init__(self, parent):
        tk.Frame.__init__(self, parent)

        self.frame = tk.Toplevel(self)
        self.master = parent

        self.__binOutput = StringVar()
        self.__binOutput.set("-")

        self.setGUI()

    def setGUI(self):
        self.frame.wm_title("Ausgabe der E/A-Einheit")
        self.frame.wm_geometry("320x240")
        self.frame.wm_attributes("-topmost", 1)
        self.frame.protocol("WM_DELETE_WINDOW", self.close)

        numberLabel = Label(self.frame, textvariable=self.__binOutput, fg="blue", font="Verdana 14")

        sbx = tk.Scrollbar(self.frame, orient="horizontal")
        sby = tk.Scrollbar(self.frame)

        self.output = tk.Text(self.frame)
        self.output.config(wrap="word")  # wrap="word"  word char

        self.output["xscrollcommand"] = sbx.set
        sbx["command"] = self.output.xview
        self.output["yscrollcommand"] = sby.set
        sby["command"] = self.output.yview

        numberLabel.pack(padx=10, pady=10, anchor=W)
        self.output.pack(fill='both', padx=10, pady=10)

    def clear(self):
        self.output.delete('1.0', END)

    def add(self, text):
        if text.isdigit():
            # Binaerdarstellung
            self.__binOutput.set("{0:b}".format(int(text)))

        self.output.insert(END, text)

    def close(self):
        self.frame.destroy()
        self.master.on_closing()
