#!/usr/bin/python
# -*- coding: utf-8 -*-

import re

from befehl import *
from konstanten import *

class Compiler:

    def indexof(self, char, string):
        return string.index(char) if char in string else -1

    def wildcards(self, line):
        line = line.strip()
        line = line.replace("\t", " ")
        line = line.replace("  ", " ")

        return line

    def checkSourceCode(self, sourceCode):
        sourceCode = sourceCode.split("\n")
        ram = []

        for lineOld in sourceCode:
            line = self.wildcards(lineOld)
            comment = ""
            marker = ""
            bef = None

            index = -1

            index = self.indexof("//", line)

            "Kommentar"
            if index > -1:
                comment = line[index+2:].strip()
                if index == 0:
                    continue  # Kommentar am Anfag der Zeile

                line = line[:index-1].strip()
                if len(line) == 0:
                    continue  # Zeile nur mit Kommentar
            else:
                index = self.indexof(";", line)

                if index > -1:
                    comment = line[index+1:].strip()
                    if index == 0:
                        continue  # Kommentar am Anfag der Zeile

                    line = line[:index-1].strip()
                    if len(line) == 0:
                        continue  # Zeile nur mit Kommentar

            "LiesZahl"
            liesZahlText = ""
            index = self.indexof('"', line)

            if index > -1:
                items2 = line.split('"')
                if len(items2) > 1:
                    liesZahlText = items2[1]
                    ret = []
                    chars = list(line)

                    status = 0
                    for i in range(0, len(chars)):
                        if status == 0:
                            if chars[i] == '"':
                                status = 1
                            ret.append(chars[i])

                        elif status == 1:
                            if chars[i] == '"':
                                status = 2
                                ret.append(chars[i])
                            else:
                                if chars[i] != ' ':
                                    ret.append(chars[i])

                        elif status == 2:
                            ret.append(chars[i])

                    line = ''.join(ret)

            # Next
            index = self.indexof(":", line)

            if index > -1:
                marker = line[:index].upper()
                line = line[index+1:].strip()
                if len(line) == 0:
                    line = "NOP"
            else:
                marker = ""

            index = 1
            bef = self.checkBefehl(lineOld, line, liesZahlText)

            if bef is not None:
                bef.oriline = lineOld.strip()  # fuer alle Faelle
                if not bef.error:
                    bef.markertext = marker
                    bef.comment = comment

                    if len(marker) > 0:
                        if not self.checkAdresse(marker):
                            bef.oriline = lineOld
                            bef.errorText = "Die Sprungmarke ist fehlerhaft! " + bef.errorText
                            bef.error = True
                else:
                    if len(marker) > 0:
                        if not self.checkAdresse(marker):
                            bef.errorText = "Die Sprungmarke ist fehlerhaft! " + bef.errorText

                ram.append(bef)  # in main pruefen, ob error = true

        return ram

    def checkBefehl(self, oriLine, befehl, liesZahlText):
        index = 0
        constreg = 0
        main = ""
        konstante = 0
        reg = 0
        bef = None

        if len(befehl) == 0:
            return bef

        befehl = befehl.upper()
        items = befehl.split(" ")  # add   {akku}  {1,reg}  {2}
        constReg = ["MOV", "ADD", "SUB", "MOD", "MULT", "DIV", "AND", "OR", "XOR", "SHL", "SHR", "CMP"]

        for search in constReg:
            if items[0] == search:
                constreg = 1
                main = search

                # check mov reg 1
                if len(items) > 1:
                    #  mov akku 1 oder  mov akku reg 1
                    if items[1] == "AKKU":
                        constreg = 1
                        break

                    # mov reg 1 AKKU
                    if items[1] == "REG":
                        constreg = 2
                        break
                break

        # Add Akku  Reg x
        # Add Akku x
        if constreg == 1:
            if len(items) == 1:
                bef = Befehl("Bitte den Begriff \"Akku\" einfügen\r\n")
                return bef

            if items[1] not in ["AKKU", "REG"]:
                bef = Befehl("Bitte den Begriff \"Akku\" oder \"Reg\" nach dem Befehl einfügen\r\n")
                return bef

            if len(items) < 3:
                bef = Befehl("Bitte ein Register oder eine Konstante eingeben\r\n   "
                             "Beispiel: (Add Akku 2 oder Add Akku Reg 1");
                return bef

            if items[2].startswith("REG"):
                if items[2] != "REG":
                    bef = Befehl("Der Befehl Reg darf keine Zahl haben (Beispiel: mov Akku Reg 1)\r\n")
                    return bef

                if items[2] == "REG":
                    if len(items) < 4:
                        bef = Befehl("Bitte ein Register nach dem Begriff \"Reg\" eingeben.\r\n   "
                                     "Beispiel: \"add akku reg 2\"")
                        return bef

                    error, reg = self.checkRegister(items[3])
                    if len(error) > 0:
                        bef = Befehl(error)
                        return bef

                    if main == "MOV":
                        bef = Befehl(None, Konstanten.C_Move_Akku_Reg, reg)
                    elif main == "ADD":
                        bef = Befehl(None, Konstanten.C_Add_Akku_Reg, reg)
                    elif main == "SUB":
                        bef = Befehl(None, Konstanten.C_Sub_Akku_Reg, reg)
                    elif main == "MOD":
                        bef = Befehl(None, Konstanten.C_Mod_Akku_Reg, reg)
                    elif main == "MULT":
                        bef = Befehl(None, Konstanten.C_Mult_Akku_Reg, reg)
                    elif main == "DIV":
                        bef = Befehl(None, Konstanten.C_Div_Akku_Reg, reg)
                    elif main == "AND":
                        bef = Befehl(None, Konstanten.C_And_Akku_Reg, reg)
                    elif main == "OR":
                        bef = Befehl(None, Konstanten.C_Or_Akku_Reg, reg)
                    elif main == "XOR":
                        bef = Befehl(None, Konstanten.C_Xor_Akku_Reg, reg)
                    elif main == "SHL":
                        bef = Befehl(None, Konstanten.C_SHL_Akku_Reg, reg)
                    elif main == "SHR":
                        bef = Befehl(None, Konstanten.C_SHR_Akku_Reg, reg)
                    elif main == "CMP":
                        bef = Befehl(None, Konstanten.C_CMP_Akku_Reg, reg)
                    else:
                        bef = Befehl("Fehler")
            else:
                # Konstanten
                error, konstante = self.checkKonstante(items[2])

                if len(error) > 0:
                    bef = Befehl(error)
                    return bef

                if main == "MOV":
                    bef = Befehl(None, Konstanten.C_Move_Akku_Const, konstante)
                elif main == "ADD":
                    bef = Befehl(None, Konstanten.C_Add_Akku_Const, konstante)
                elif main == "SUB":
                    bef = Befehl(None, Konstanten.C_Sub_Akku_Const, konstante)
                elif main == "MOD":
                    bef = Befehl(None, Konstanten.C_Mod_Akku_Const, konstante)
                elif main == "MULT":
                    bef = Befehl(None, Konstanten.C_Mult_Akku_Const, konstante)
                elif main == "DIV":
                    bef = Befehl(None, Konstanten.C_Div_Akku_Const, konstante)
                elif main == "AND":
                    bef = Befehl(None, Konstanten.C_And_Akku_Const, konstante)
                elif main == "OR":
                    bef = Befehl(None, Konstanten.C_Or_Akku_Const, konstante)
                elif main == "XOR":
                    bef = Befehl(None, Konstanten.C_Xor_Akku_Const, konstante)
                elif main == "SHL":
                    bef = Befehl(None, Konstanten.C_SHL_Akku_Const, konstante)
                elif main == "SHR":
                    bef = Befehl(None, Konstanten.C_SHR_Akku_Const, konstante)
                elif main == "CMP":
                    bef = Befehl(None, Konstanten.C_CMP_Akku_Const, konstante)
                else:
                    bef = Befehl("Fehler")

            return bef

        if constreg == 2:
            # in main steht der Hauptbefehl, also  "mov Reg 1 Akku"
            if items[1] != "REG":
                # Error
                bef = Befehl("Der Reg Eintrag fehlt")
                return bef
            if len(items) == 1:
                bef = Befehl("Bitte den Begriff \"Register\" eingeben: mov Reg 1 Akku")
                return bef
            if len(items) == 2:
                bef = Befehl("Bitte ein Register eingeben: mov Reg 1 Akku")
                return bef
            if len(items) == 3:
                bef = Befehl("Bitte den Akku eingeben: mov Reg 1 Akku")
                return bef

            error, reg = self.checkRegister(items[2])
            if len(error) > 0:
                bef = Befehl(error)
                return bef
            else:
                error = None

            bef = Befehl(error, Konstanten.C_Move_Reg_Akku, reg)
            return bef

        # ROR ROL
        ok = False
        rorrol = ["ROR", "ROL"]

        for search in rorrol:
            if items[0] == search:
                main = search
                ok = True
                break

        if ok:
            if not (items[1] == "AKKU"):
                bef = Befehl("ROL und ROR benoetigen Akku als Parameter!")
                return bef

            error, konstante = self.checkKonstante(items[2])
            if len(error) > 0:
                bef = Befehl(error)
                return bef

            if main == "ROL":
                bef = Befehl(None, Konstanten.C_ROL_Akku_Const, konstante)
            elif main == "ROR":
                bef = Befehl(None, Konstanten.C_ROR_Akku_Const, konstante)
            else:
                bef = Befehl("Fehler")

        ok = False
        inout = ["IN", "OUT"]

        for search in inout:
            if items[0] == search:
                main = search
                ok = True
                break

        if ok:
            if items[1] == "NL":
                bef = Befehl(None, Konstanten.C_OUT_NL, 0)
                return bef

            if items[1] not in ["AKKU", "AKKUHEX", "REG", "REGHEX", "STRING"]:
                bef = Befehl("Der Akku, Reg oder String Eintrag fehlt!")
                return bef

            if items[1] in ["REG", "REGHEX"]:
                error, reg = self.checkRegister(items[2])
                if len(error) > 0:
                    bef = Befehl(error)
                    return bef

                if main == "IN":
                    bef = Befehl(None, Konstanten.C_IN_REG, reg)
                elif main == "OUT":
                    if items[1].upper() == "REGHEX":
                        bef = Befehl(None, Konstanten.C_OUT_REGHex, reg)
                    else:
                        bef = Befehl(None, Konstanten.C_OUT_REG, reg)
                else:
                    bef = Befehl("FEHLER")
            else:
                if items[1] == "STRING":
                    if not (items[0] == "OUT"):
                        bef = Befehl("Die String-Ausgabe hat die Syntax OUT STRING \"Text\"")
                        return bef

                    bef = Befehl(None, Konstanten.C_OUT_STRING, 0)
                    items2 = oriLine.split('"')
                    if len(items2) > 1:
                        bef.ausgabeString = items2[1]

                    return bef
                else:
                    if main == "IN":
                        if len(items) > 2:
                            return Befehl("Nach IN Akku darf kein weiteres Element")

                        bef = Befehl(None, Konstanten.C_IN_Akku, 0)
                    elif main == "OUT":
                        if len(items) > 2:
                            return Befehl("Nach OUT Akku darf kein weiteres Element")
                        if items[1].upper() == "AKKUHEX":
                            bef = Befehl(None, Konstanten.C_OUT_AkkuHex, 0)
                        else:
                            bef = Befehl(None, Konstanten.C_OUT_Akku, 0)
                    else:
                        bef = Befehl("FEHLER")

            return bef

        ok = False
        incdecnot = ["INC", "DEC", "DAA", "DAS", "NOT"]  # INC AKKU     DEC AKKU NOT AKKU

        for search in incdecnot:
            main = search
            if items[0] == search:
                ok = True
                break

        if ok:
            if len(items) < 2:
                bef = Befehl("Bitte den Begriff \"Akku\" nach dem Befehl eingeben")
                return bef
            if not (items[1] == "AKKU"):
                bef = Befehl("Inc, Dec, Not benötigen Akku als Parameter")
                return bef

            if main == "INC":
                bef = Befehl(None, Konstanten.C_INC, 0)
            elif main == "DEC":
                bef = Befehl(None, Konstanten.C_DEC, 0)
            elif main == "DAA":
                bef = Befehl(None, Konstanten.C_DAA, 0)
            elif main == "DAS":
                bef = Befehl(None, Konstanten.C_DAS, 0)
            elif main == "NOT":
                bef = Befehl(None, Konstanten.C_Not_Akku, 0)
            else:
                bef = Befehl("FEHLER")

            return bef

        if items[0] == "JUMP":
            if not self.checkAdresse(items[1]):
                bef = Befehl("Die Sprungmarke ist fehlerhaft!")
                return bef

            bef = Befehl(None, Konstanten.C_JUMP, 0)
            bef.zielmarkertext = items[1]

            return bef

        ok = False
        jumpi = ["JZ", "JNZ", "JS", "JNS", "JC", "JNC", "JP", "JNP", "JL", "JLE", "JG", "JGE"]

        for search in jumpi:
            main = search
            if items[0] == search:
                ok = True
                break

        if ok:
            if not self.checkAdresse(items[1]):
                bef = Befehl("Die Sprungsmarke ist fehlerhaft")
                return bef

            if main == "JZ":
                bef = Befehl(None, Konstanten.C_JZ, 0)
            elif main == "JNZ":
                bef = Befehl(None, Konstanten.C_JNZ, 0)
            elif main == "JS":
                bef = Befehl(None, Konstanten.C_JS, 0)
            elif main == "JNS":
                bef = Befehl(None, Konstanten.C_JNS, 0)
            elif main == "JC":
                bef = Befehl(None, Konstanten.C_JC, 0)
            elif main == "JNC":
                bef = Befehl(None, Konstanten.C_JNC, 0)
            elif main == "JL":
                bef = Befehl(None, Konstanten.C_JL, 0)
            elif main == "JLE":
                bef = Befehl(None, Konstanten.C_JLE, 0)
            elif main == "JG":
                bef = Befehl(None, Konstanten.C_JG, 0)
            elif main == "JGE":
                bef = Befehl(None, Konstanten.C_JGE, 0)
            elif main == "JP":
                bef = Befehl(None, Konstanten.C_JP, 0)
            elif main == "JNP":
                bef = Befehl(None, Konstanten.C_JNP, 0)
            else:
                bef = Befehl("FEHLER")

            if bef is not None:
                bef.zielmarkertext = items[1]

            return bef

        # index = befehl.IndexOf("LIESZAHL");
        if items[0] == "LIESZAHL":
            if len(items) < 2:
                bef = Befehl("Der Befehl LiesZahl benötigt noch einen Text")
                return bef

            if len(items) != 2:
                bef = Befehl("Der Befehl LiesZahl darf nur nach 'Lieszahl' nur noch den Text haben")
                return bef

            if (not items[1].startswith("\"")) or (not items[1].endswith("\"")):
                bef = Befehl("Der Befehl LiesZahl benötigt noch einen Text, der von\" umschlossen wird")
                return bef

            bef = Befehl(None, Konstanten.C_IN_A_LIESC, 0)
            bef.liesZahltext = liesZahlText

            return bef

        index = self.indexof("CLEARCARRY", befehl)
        if index > -1:
            bef = Befehl(None, Konstanten.C_ClearCarry, 0)
            return bef

        index = self.indexof("NOP", befehl)
        if index > -1:
            bef = Befehl(None, Konstanten.C_NOP, 0)
            return bef

        index = self.indexof("CLEARREGISTER", befehl)
        if index > -1:
            bef = Befehl(None, Konstanten.C_CLEARREGISTER, 0)
            return bef

        index = self.indexof("STOP", befehl)
        if index > -1:
            bef = Befehl(None, Konstanten.C_STOP, 0)
            return bef

        bef = Befehl("Der Befehl '" + items[0] + "' wurde nicht erkannt")
        return bef

    def checkRegister(self, sNumber):
        register = 0

        if not sNumber.isdigit():
            return "Die Register Zahl ist nicht numerisch!", -1

        register = int(sNumber, 0)
        if register < 0 or register > Konstanten.MAX_REGISTER:
            return "Das Register ist nicht im gueltigen Bereich (0 bis " + str(Konstanten.MAX_REGISTER) + ")!", -1

        return "", register

    def checkKonstante(self, sNumber):
        konstante = -1
        sNumber = sNumber.upper()
        numberFormat = 10

        if sNumber.endswith("H"):
            sNumber = sNumber[:len(sNumber) - 1]
            numberFormat = 16

            if not sNumber.isdigit():
                return "Die Konstante ist nicht numerisch!", -1

        else:
            if not sNumber.isdigit():
                return "Die Konstante ist nicht numerisch!", -1

        konstante = int(sNumber, numberFormat)
        if konstante < 0 or konstante > Konstanten.MAX_WERT:
            return "Die Konstante ist nicht im gueltigen Bereich (0 bis " + str(Konstanten.MAX_WERT) + ")!", -1

        return "", konstante

    def checkAdresse(self, sprungmarke):
        ret = re.match(r'^[A-Z]+[A-Z0-9]*', sprungmarke)
        return True if (ret is not None) else False
