#!/usr/bin/python
# -*- coding: utf-8 -*-

import tkinter as tk
from tkinter.ttk import *
from tkinter.simpledialog import *


class ErrorWindow(tk.Frame):
    def __init__(self, parent, errorText, fileName):
        tk.Frame.__init__(self, parent)

        self.frame = tk.Toplevel(self)
        self.master = parent

        self.setGUI(errorText, fileName)

    def setGUI(self, errorText, fileName):
        self.frame.wm_title("Anzeige der Compiler-Fehler")

        self.frame.grid_rowconfigure(0, weight=0)
        self.frame.grid_rowconfigure(1, weight=1)
        self.frame.grid_columnconfigure(0, weight=1)

        fileLabel = Label(self.frame, text="Datei: " + fileName, fg="blue", font="Verdana 14")

        sbx = tk.Scrollbar(self.frame, orient="horizontal")
        sby = tk.Scrollbar(self.frame)

        messageEditor = tk.Text(self.frame, font="Verdana 10")
        messageEditor.config(wrap="none")  # wrap="word"  word char

        messageEditor["xscrollcommand"] = sbx.set
        sbx["command"] = messageEditor.xview
        messageEditor["yscrollcommand"] = sby.set
        sby["command"] = messageEditor.yview

        messageEditor.insert("end", errorText)

        fileLabel.grid(row=0, padx=10, pady=10, sticky='w')
        messageEditor.grid(row=1, padx=10, pady=10, sticky='nsew')
