#!/usr/bin/python
# -*- coding: utf-8 -*-

import tkinter as tk
from tkinter.simpledialog import *
from tkinter.ttk import *
from tkinter import *
from tkinter import messagebox


class InputWindow(tk.simpledialog.Dialog):
    __bit7 = 0
    __bit6 = 0
    __bit5 = 0
    __bit4 = 0
    __bit3 = 0
    __bit2 = 0
    __bit1 = 0
    __bit0 = 0
    __hexInput = ""
    __dezInput = ""

    __selectedTab = -1
    __tabCtrl = None

    def body(self, master):
        self.__bit7 = IntVar()
        self.__bit6 = IntVar()
        self.__bit5 = IntVar()
        self.__bit4 = IntVar()
        self.__bit3 = IntVar()
        self.__bit2 = IntVar()
        self.__bit1 = IntVar()
        self.__bit0 = IntVar()
        self.__hexInput = StringVar()
        self.__dezInput = StringVar()

        Label(master, text="Lese obere Grenze n", foreground="blue", font="Verdana 14")\
            .pack(expand=True, fill="both")

        self.__tabCtrl = ttk.Notebook(master)

        dezFrame = ttk.Frame(self.__tabCtrl)
        binFrame = ttk.Frame(self.__tabCtrl)
        hexFrame = ttk.Frame(self.__tabCtrl)

        self.buildDezimalFrame(dezFrame)
        self.buildBinFrame(binFrame)
        self.buildHexFrame(hexFrame)

        self.__tabCtrl.add(dezFrame, text='Dezimalwert')
        self.__tabCtrl.add(binFrame, text='Binärwert')
        self.__tabCtrl.add(hexFrame, text='Hexadezimalwert')
        self.__tabCtrl.pack(expand=True, fill="both")

        return dezFrame

    def buildDezimalFrame(self, dezFrame):
        """ Dezimalreiter """
        Label(dezFrame, text="Neuer Wert für die E/A-Einheit", foreground="red", font="Verdana 14")\
            .grid(row=0, column=0)
        Spinbox(dezFrame, from_=0, to=65536, increment=1, validate='all', textvariable=self.__dezInput)\
            .grid(row=1, column=0, sticky=N+W+E+S, padx="15", pady="15")

    def buildBinFrame(self, binFrame):
        """ Binaerreiter """
        Label(binFrame, text="Neuer Wert für die E/A-Einheit", foreground="red", font="Verdana 14")\
            .grid(row=0, column=0, columnspan=8)

        Checkbutton(binFrame, text="Bit 7", variable=self.__bit7).grid(row=1, column=0, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 6", variable=self.__bit6).grid(row=1, column=1, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 5", variable=self.__bit5).grid(row=1, column=2, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 4", variable=self.__bit4).grid(row=1, column=3, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 3", variable=self.__bit3).grid(row=1, column=4, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 2", variable=self.__bit2).grid(row=1, column=5, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 1", variable=self.__bit1).grid(row=1, column=6, padx="10", pady="10")
        Checkbutton(binFrame, text="Bit 0", variable=self.__bit0).grid(row=1, column=7, padx="10", pady="10")

    def buildHexFrame(self, hexFrame):
        """ Hexadezimalreiter """
        Label(hexFrame, text="Neuer Wert für die E/A-Einheit", foreground="red", font="Verdana 14")\
            .grid(row=0, column=0)

        Entry(hexFrame, textvariable=self.__hexInput).grid(row=1, column=0, sticky=N+W+E+S, padx="15", pady="15")

    def apply(self):
        if self.__tabCtrl is not None:
            self.__selectedTab = self.__tabCtrl.index(self.__tabCtrl.select())

    def getResult(self):
        ret = -1

        # Dezimalinput
        if self.__selectedTab == 0:
            if str(self.__dezInput.get()).isdigit():
                ret = int(self.__dezInput.get())

        # Binaerinput
        elif self.__selectedTab == 1:
            ret = int(self.__bit0.get()) << 0 | \
                  int(self.__bit1.get()) << 1 | \
                  int(self.__bit2.get()) << 2 | \
                  int(self.__bit3.get()) << 3 | \
                  int(self.__bit4.get()) << 4 | \
                  int(self.__bit5.get()) << 5 | \
                  int(self.__bit6.get()) << 6 | \
                  int(self.__bit7.get()) << 7

        # Hexinput
        elif self.__selectedTab == 2:
            try:
                ret = int(self.__hexInput.get(), 16)
            except:
                ret = -1

        return ret
