#!/usr/bin/python
# -*- coding: utf-8 -*-


class Konstanten:
    MAX_REGISTER = 20
    VERSION = 7

    IP_START_ADRESSE = 0

    MAX_WERT = 65535
    MAX_WERT_ROL = 32768
    MAX_RAM = 4000
    UNDEFINIERT = MAX_WERT + 1

    TIME = 1000

    ERR_CPU_STOP = 7
    CPU_STOP = 0

    GROUP_MOV = 1 << 6
    C_Move_Akku_Const = GROUP_MOV + 1
    C_Move_Akku_Reg = GROUP_MOV + 2
    C_Move_Reg_Akku = GROUP_MOV + 3

    GROUP_MATH = 2 << 6
    C_Add_Akku_Reg = GROUP_MATH + 1
    C_Add_Akku_Const = GROUP_MATH + 2
    C_Sub_Akku_Reg = GROUP_MATH + 3
    C_Sub_Akku_Const = GROUP_MATH + 4
    C_Mod_Akku_Reg = GROUP_MATH + 5
    C_Mod_Akku_Const = GROUP_MATH + 6
    C_Mult_Akku_Reg = GROUP_MATH + 7
    C_Mult_Akku_Const = GROUP_MATH + 8
    C_Div_Akku_Reg = GROUP_MATH + 9
    C_Div_Akku_Const = GROUP_MATH + 10
    C_INC = GROUP_MATH + 11
    C_DEC = GROUP_MATH + 12
    C_DAA = GROUP_MATH + 13
    C_DAS = GROUP_MATH + 14

    GROUP_LOGIC = 3 << 6
    C_And_Akku_Reg = GROUP_LOGIC + 1
    C_And_Akku_Const = GROUP_LOGIC + 2
    C_Or_Akku_Reg = GROUP_LOGIC + 3
    C_Or_Akku_Const = GROUP_LOGIC + 4
    C_Xor_Akku_Reg = GROUP_LOGIC + 5
    C_Xor_Akku_Const = GROUP_LOGIC + 6
    C_Not_Akku = GROUP_LOGIC + 7

    GROUP_SHIFT = 4 << 6
    C_SHL_Akku_Reg = GROUP_SHIFT + 1
    C_SHL_Akku_Const = GROUP_SHIFT + 2
    C_SHR_Akku_Reg = GROUP_SHIFT + 3
    C_SHR_Akku_Const = GROUP_SHIFT + 4
    C_ROL_Akku_Const = GROUP_SHIFT + 5
    C_ROR_Akku_Const = GROUP_SHIFT + 6

    GROUP_JMP = 5 << 6
    C_CMP_Akku_Reg = GROUP_JMP + 1
    C_CMP_Akku_Const = GROUP_JMP + 2
    C_JUMP = GROUP_JMP + 3
    C_JZ = GROUP_JMP + 4
    C_JNZ = GROUP_JMP + 5
    C_JS = GROUP_JMP + 6
    C_JNS = GROUP_JMP + 7
    C_JL = GROUP_JMP + 8
    C_JLE = GROUP_JMP + 9
    C_JG = GROUP_JMP + 10
    C_JGE = GROUP_JMP + 11
    C_JC = GROUP_JMP + 12
    C_JNC = GROUP_JMP + 13
    C_JP = GROUP_JMP + 14
    C_JNP = GROUP_JMP + 15

    GROUP_E_A = 6 << 6  # 384 = 180h
    C_IN_Akku = GROUP_E_A + 1
    C_IN_REG = GROUP_E_A + 2
    C_OUT_Akku = GROUP_E_A + 3
    C_OUT_REG = GROUP_E_A + 4
    C_OUT_NL = GROUP_E_A + 5
    C_IN_A_LIESC = GROUP_E_A + 6
    C_OUT_STRING = GROUP_E_A + 7
    C_OUT_AkkuHex = GROUP_E_A + 8
    C_OUT_REGHex = GROUP_E_A + 9

    GROUP_CTRL = 7 << 6  # 448 = 1C0
    C_ClearCarry = GROUP_CTRL + 1
    C_IRet = GROUP_CTRL + 2
    C_NOP = GROUP_CTRL + 3
    C_Gosub2 = GROUP_CTRL + 4
    C_CLEARREGISTER = GROUP_CTRL + 5
    C_STOP = GROUP_CTRL + 6
