#!/usr/bin/python
# -*- coding: utf-8 -*-

from register import *
from befehl import *


class RamRegister:
    __instance = None
    __ram = []
    __regs = []

    # Singleton
    def __new__(cls):
        if RamRegister.__instance is None:
            RamRegister.__instance = object.__new__(cls)

        return RamRegister.__instance

    def __init__(self):
        for i in range(0, Konstanten.MAX_REGISTER):
            self.__regs.append(Register(65535, ""))

    def clear(self):
        self.__ram.clear()
        for reg in self.__regs:
            reg.comment = ""
            reg.number = 0

    def clearRegister(self):
        for reg in self.__regs:
            reg.number = 0

    def addCommand(self, bef):
        self.__ram.append(bef)

    def countRam(self):
        return len(self.__ram)

    def getBefehl(self, index):
        if 0 <= index < len(self.__ram):
            return self.__ram[index]
        else:
            return None

    def getRegister(self, index):
        if 0 <= index < len(self.__regs):
            return self.__regs[index]
        else:
            return None

    def setRegister(self, index, reg=None, ordernr=None, comment=None):
        if 0 <= index < Konstanten.MAX_REGISTER:
            if reg is not None:
                self.__regs[index] = reg
            if ordernr is not None:
                self.__regs[index].number = ordernr
            if comment is not None:
                self.__regs[index].comment = comment
