#! /usr/bin/env python3
# coding=utf8


import os
import tkinter
from tkinter.ttk import *
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master):

		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")	# 
		self.setGUI()

	def setGUI(self):
		# pack ist wie das DockPanel in WPF
		# erst muessen die "normalen" UI-Elemente eintgetragen werden
		# am Schluss werden die UI-Elemente eingetragen, die fill="both" haben
		buttonframe = tkinter.Frame(self)
		buttonframe.pack(fill="x", side="bottom", padx="5", pady="5")

		self.bnEsc = tkinter.Button(buttonframe)
		self.bnEsc["text"] = "Beenden"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(padx="5", side="right")

		self.bnAction = tkinter.Button(buttonframe)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right")
		self.bnAction.config(foreground= "green")
		self.bnAction.config(activebackground= "yellow")



		frame1 = tkinter.Frame(self)
		frame1.pack(expand=True, fill="both", side="top", padx="5", pady="5")


		ysb = tkinter.Scrollbar(frame1) # , command=self.tree.yview
		ysb.pack(fill="y",side="right")

		xsb = tkinter.Scrollbar(frame1, orient="horizontal")
		xsb.pack(fill="x",side="bottom")

		self.tree = tkinter.ttk.Treeview(frame1)
		self.tree.pack(fill="both",expand=True)
		self.tree["xscrollcommand"] = xsb.set
		xsb["command"]=self.tree.xview
		ysb["command"]=self.tree.yview

		path = "D:\\QGIS\\"
		# self.tree.configure(yscroll=ysb.set, xscroll=xsb.set)
		self.tree.heading('#0', text=path, anchor='w')

		abspath = os.path.abspath(path)
		root_node = self.tree.insert('', 'end', text=abspath, open=True)
		self.process_directory(root_node, abspath)


	def process_directory(self, parent, path):
		for p in os.listdir(path):
			abspath = os.path.join(path, p)
			isdir = os.path.isdir(abspath)
			oid = self.tree.insert(parent, 'end', text=p, open=False)
			if isdir:
				self.process_directory(oid, abspath)


	def onAction(self):
		messagebox.showinfo( "Hello Python", "action")

root = tkinter.Tk()
root.title("Mein Fenster")
root.geometry("450x600")
app = MyApp(root)
app.mainloop()