#! /usr/bin/env python3
# coding=utf8
import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both") 
		self.setGUI()

	def setGUI(self):
		frame = tkinter.Frame(self)
		frame.pack(fill="x", side="top",padx="5",pady="5" ) 	 # fill=x,y,both

		self.label1 = tkinter.Label(frame)
		self.label1["text"] = "Eingabe der Zahl"
		self.label1.pack(side="left")

		self.spinbox = tkinter.Spinbox(frame, from_=0, to=255)
		self.spinbox.activebackground = "blue"
		self.spinbox.pack(expand=True,fill="x",padx="5",pady="5")
		
		self.var_spinbox = tkinter.IntVar()
		self.var_spinbox.set(0)
		self.spinbox["textvariable"] = self.var_spinbox

		#   -------------

		frame2 = tkinter.Frame(self)
		frame2.config(bg="#FFCCCC")
		frame2.pack(fill="x", side="bottom",padx="5",pady="5" ) 	 # fill=x,y,both
		self.bnEsc = tkinter.Button(frame2)
		self.bnEsc["text"] = "Ende"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(side="right", padx="5")

		self.bnAction  = tkinter.Button(frame2)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right", padx="5")

	# man kann trotz Radionbutton Text eingeben, dann stürzt das Programm ab
	def onAction(self):
		try:
			zahl = self.var_spinbox.get()
		except ValueError as e:
			messagebox.askokcancel( "Meldung", str(zahl) )
			print("Fehlerhafte Zahl")
			return
		if zahl<0 or zahl>255:
			messagebox.askokcancel( "Fehler", str(zahl) )
		else:
			messagebox.askokcancel( "Meldung", str(zahl) )

root = tkinter.Tk()
root.title("InputValue")
root.geometry("250x100")
app = MyApp(root)
app.mainloop()
