#! /usr/bin/env python3
# coding=utf8
import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both") 
		self.setGUI()

	def setGUI(self):
		frame = tkinter.Frame(self)
		frame.pack(fill="x", side="top",padx="5",pady="5" ) 	 # fill=x,y,both

		self.label1 = tkinter.Label(frame)
		self.label1["text"] = "Eingabe der Zahl"
		self.label1.pack(side="left")

		self.inputui = tkinter.Entry(frame)
		self.inputui.config(bg="blue")
		self.inputui.config(fg="#FFFFFF")
		self.inputui.pack(fill="x")

		self.var_inputfield = tkinter.IntVar()
		self.var_inputfield.set(12)
		self.inputui["textvariable"] = self.var_inputfield

		#   -------------

		frame2 = tkinter.Frame(self)
		frame2.config(bg="#FFCCCC")
		frame2.pack(fill="x", side="bottom",padx="5",pady="5" ) 	 # fill=x,y,both
		self.bnEsc = tkinter.Button(frame2)
		self.bnEsc["text"] = "Ende"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(side="right", padx="5")

		self.bnAction  = tkinter.Button(frame2)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right", padx="5")


	def onAction(self):
		try:
			zahl = self.var_inputfield.get()
		except ValueError as e:
			messagebox.askokcancel( "Meldung", str(zahl) )
			print("Fehlerhafte Zahl")
			return
		if zahl<0 or zahl>255:
			messagebox.askokcancel( "Fehler", str(zahl) )
		else:
			messagebox.askokcancel( "Meldung", str(zahl) )

root = tkinter.Tk()
root.title("InputValue")
root.geometry("250x100")
app = MyApp(root)
app.mainloop()
